(function () {
	var extensionForm = $("#extensions_form");
	var attach_toggle = $("#extensions_form #extensionsvoicemail input#attach");
	var delete_toggle = $("#extensions_form #extensionsvoicemail input#delete");
	var delete_toggle_labels = $("#extensions_form #extensionsvoicemail div.form-group-delete label");

	extensionForm.validate(Validations);
	var getEditExtensionMode = function (id) {
		pbx_request("extensions", "getContent", "edit", id);
	};
	extensionForm.find("[name='extension']").autocomplete({
		source : extAutoComplete,
		select : function (event, ui) {
			getEditExtensionMode(ui.item.id);
		}
	});
	extensionForm.on("focusout", "[name='extension']", function () {
		var extension = $(this).val();
		if (extensions[extension] !== undefined) {
			getEditExtensionMode(extensions[extension]);
		}
	}).on("keyup", "[name='extension']", function() {
		var extension = $(this).val();
		extensionForm.find("#user").val(extension);
		extensionForm.find("#portal_user").val(extension);
		extensionForm.find("#vm_password").val(extension);
	}).on("keyup", "[name='name']", function() {
		extensionForm.find("#dev_description").val($(this).val());
	});

	var pass_obj = {};
	pass_obj.class = 'extensions';
	pass_obj.method = 'show_strength';
	pass_obj.value = '';
	pass_obj.bar_selector = "#extensions_form div.password_strength";

	extensionForm.find("input#secret").bind('keyup', function() {
		pass_obj.value = extensionForm.find("input#secret").val();
		show_pass_strength(pass_obj);
	});

	var change_technology = function () {
		var technology = extensionForm.find("[name='technology']:checked").val();
		if (technology === undefined) {
			technology = extensionForm.find("[name='technology']").val();
		}
		var device_form = extensionForm.find(".device-form").show();

		switch (technology) {
			case "sip": {
				extensionForm.find(".iax-tech, .fxs-tech").each(function () {
					$(this).addClass("ignore").closest(".form-group").hide();
				});
				extensionForm.find(".sip-tech").each(function () {
					$(this).removeClass("ignore").closest(".form-group").show();
				});
				break;
			}
			case "iax": {
				extensionForm.find(".sip-tech, .fxs-tech").each(function () {
					$(this).addClass("ignore").closest(".form-group").hide();
				});
				extensionForm.find(".iax-tech").each(function () {
					$(this).removeClass("ignore").closest(".form-group").show();
				});
				break;
			}
			case "fxs": {
				extensionForm.find(".iax-tech, .sip-tech").each(function () {
					$(this).addClass("ignore").closest(".form-group").hide();
				});
				extensionForm.find(".fxs-tech").each(function () {
					$(this).addClass("ignore").closest(".form-group").show();
				});
				break;
			}
			case "none": {
				extensionForm.find(".iax-tech, .sip-tech, .fxs-tech").each(function () {
					$(this).addClass("ignore").closest(".form-group").hide();
				});
				device_form.hide();
				break;
			}
		}
		pass_obj.value = extensionForm.find("input#secret").val();
		show_pass_strength(pass_obj);
	};
	extensionForm.on("change", "[name='device_id']", function () {
		var device_id = $(this).val();
		var extension_id = extensionForm.find("[name='extension_id']").val();
		var mode = (device_id == "new") ? "add" : "edit";
		pbx_request("extensions", "getDevice", mode, device_id + "|" + extension_id, null, false).done(
			change_technology
		).complete(function() {
			extensionForm.find("input#secret").bind('keyup', function() {
				pass_obj.value = extensionForm.find("input#secret").val();
				show_pass_strength(pass_obj);
			})
		});
	});
	extensionForm.on("change", "[name='technology']", change_technology);
	extensionForm.find("button.frmactions-unlink-device").on("click", function() {
		var device_id = extensionForm.find("[name='device_id']").val();
		pbx_request("extensions", "unlink", "delete", device_id);
	});
	change_technology();
	pass_obj.value = extensionForm.find("input#secret").val();
	show_pass_strength(pass_obj);

	$("#extensions_form #extensionsvoicemail input#attach").on('change', function() {
		gray_out(attach_toggle,delete_toggle,delete_toggle_labels);
	});
	gray_out(attach_toggle,delete_toggle,delete_toggle_labels);
})();
